#2377 closed defect (wontfix)

rtems_waf: Tools without a version are not supported

Reported by: Sebastian Huber Owned by:
Priority: normal Milestone: 5.1
Component: tool Version: 5
Severity: normal Keywords:
Cc: Daniel Hellstrom Blocked By:
Blocking:

Description

waf configure --prefix=/opt/rtems --rtems=/opt/rtems --rtems-tools=/opt/rtems --rtems-bsps=i386/pc686
Setting top to : /scratch/git-rtems-libbsd
Setting out to : /scratch/git-rtems-libbsd/build
Could not find any architectures
(complete log in /scratch/git-rtems-libbsd-upstream/build/config.log)

Change History (14)

comment:1 Changed on Jul 31, 2015 at 10:17:34 PM by Chris Johns

I do not understand the issue. What does tools without a version mean ?

comment:2 Changed on Sep 11, 2015 at 9:03:45 AM by Sebastian Huber

For example sparc-rtems-gcc, etc.

This is used by some third-party tools, like the Gaisler RCC.

comment:3 Changed on Sep 13, 2015 at 10:49:42 PM by Chris Johns

The rtems_waf module is designed to look at a standard versioned RTEMS tree that is built and installed. We have had versioning since 4.7. The module checks for the architectures requested are installed versioned. Changes to stop this adds complexity and increase testing in an area I would prefer not to do.

I understood Gaisler is supporting versioned tools. What other 3rd party tool set are you referring to ?

comment:4 Changed on Sep 14, 2015 at 6:18:41 AM by Sebastian Huber

The RCC archives use a version:

http://gaisler.com/anonftp/rcc/bin/linux/

However, the tools use all a sparc-rtems- prefix without a version.

I found it convenient to use this scheme for the RTEMS master as well. You can build the tools with an arbitrary string after the target-rtems, e.g. sparc-rtemsfoobarblug99.abc is also allowed.

comment:5 in reply to:  4 ; Changed on Sep 14, 2015 at 6:35:54 AM by Chris Johns

Replying to sebastian.huber:

The RCC archives use a version:

http://gaisler.com/anonftp/rcc/bin/linux/

These look like old tools. My understanding is un-versioned tools would not be be part of any 4.11 version and the last un-versioned tools by Gaisler was 4.10.

However, the tools use all a sparc-rtems- prefix without a version.

We should not and really cannot support un-versioned tools in the project. I will discourage any efforts to make it supported.

I found it convenient to use this scheme for the RTEMS master as well. You can build the tools with an arbitrary string after the target-rtems, e.g. sparc-rtemsfoobarblug99.abc is also allowed.

Did you try the --rtems-version option, ie --rtems-version=foobarblug99.abc ?

I support any version label and encourage custom ones for a specific user build. It is just no versioning I wish to discourage.

Note, the waf based rtems-config support has a bug with a hardcoded version.

comment:6 in reply to:  5 ; Changed on Sep 14, 2015 at 6:49:48 AM by Sebastian Huber

Cc: Daniel Hellstrom added

Replying to chrisj:

Replying to sebastian.huber:

The RCC archives use a version:

http://gaisler.com/anonftp/rcc/bin/linux/

These look like old tools. My understanding is un-versioned tools would not be be part of any 4.11 version and the last un-versioned tools by Gaisler was 4.10.

The preliminary RCC for 4.11 has still un-versioned tools:

http://www.gaisler.com/anonftp/rcc/smp/nov2014/sparc-rtems-4.11-gcc-4.9.2-1.2.99.1-linux.tar.bz2

However, the tools use all a sparc-rtems- prefix without a version.

We should not and really cannot support un-versioned tools in the project. I will discourage any efforts to make it supported.

Ok, then Gaisler should adjust their RCC structure.

I found it convenient to use this scheme for the RTEMS master as well. You can build the tools with an arbitrary string after the target-rtems, e.g. sparc-rtemsfoobarblug99.abc is also allowed.

Did you try the --rtems-version option, ie --rtems-version=foobarblug99.abc ?

I support any version label and encourage custom ones for a specific user build. It is just no versioning I wish to discourage.

Note, the waf based rtems-config support has a bug with a hardcoded version.

No, I didn't build the tools with such a version label.

comment:7 in reply to:  6 Changed on Sep 14, 2015 at 7:30:46 AM by Chris Johns

Replying to sebastian.huber:

Replying to chrisj:

Replying to sebastian.huber:

The RCC archives use a version:

http://gaisler.com/anonftp/rcc/bin/linux/

These look like old tools. My understanding is un-versioned tools would not be be part of any 4.11 version and the last un-versioned tools by Gaisler was 4.10.

The preliminary RCC for 4.11 has still un-versioned tools:

http://www.gaisler.com/anonftp/rcc/smp/nov2014/sparc-rtems-4.11-gcc-4.9.2-1.2.99.1-linux.tar.bz2

Sigh. These being in the wild un-versioned is unfortunate.

However, the tools use all a sparc-rtems- prefix without a version.

We should not and really cannot support un-versioned tools in the project. I will discourage any efforts to make it supported.

Ok, then Gaisler should adjust their RCC structure.

Yes. We have to put an end to users appearing on the mailing list with questions and we are guessing the origin of the tools. This is the reason we have asked for the change. Joel and I are clear in our understanding of what was to happen. I checked with him last night his time.

comment:8 Changed on Sep 17, 2015 at 2:27:56 PM by Daniel Hellstrom

Hi,

Joel has discussed this with us some time ago and we agreed that we need to change the RCC naming. The temporary toolchain you can find via the gaisler.com homepage used still the old prefix and built by the old build scripts we have had. We were planning on using RSB initially but has not converted to it yet, however the old build script was updated recently which generates a toolchain with the prefix "sparc-rcc-rtems4.11-" as previously discussed. So next RCC release on rtems-4.11 will have that prefix. Please let me know if you see any trouble with us using that prefix.

Regards,
Daniel

comment:9 Changed on Sep 18, 2015 at 9:07:42 PM by Joel Sherrill

The unversioned tools should still work with 4.11. There is no issue there because it is still only autoconf.

This is an issue with the waf build. That will be 4.12 or 5.x but not 4.11. We need to make sure the target used for the Gaisler tools (sparc-rcc-rtems4.11-) is accepted OK. That should only be a matter of the wildcard pattern recognizing the CPU-rtemsVERSION or CPU-vendor-rtemsVERSION form of the target. The is actually GNUitically correct since the target technically has three parts. When the vendor isn't provided, it is assumed to be unknown.

comment:10 Changed on Jan 26, 2017 at 7:05:37 AM by Sebastian Huber

Milestone: 4.114.11.2

comment:11 Changed on Mar 21, 2017 at 3:40:59 AM by Chris Johns

Milestone: 4.11.24.12
Version: 4.114.12

Moved to master.

comment:12 Changed on May 11, 2017 at 7:31:02 AM by Sebastian Huber

Milestone: 4.124.12.0

comment:13 Changed on Jun 8, 2017 at 8:35:44 AM by Sebastian Huber

Resolution: wontfix
Status: newclosed

comment:14 Changed on Nov 9, 2017 at 6:27:14 AM by Sebastian Huber

Milestone: 4.12.05.1

Milestone renamed

Note: See TracTickets for help on using tickets.